package eu.etaxonomy.taxeditor.designproposal2.view;

import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.ExpandBar;
import org.eclipse.swt.widgets.ExpandItem;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.ui.part.ViewPart;

import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

//import eu.etaxonomy.cdm.api.service.INameService;
//import eu.etaxonomy.cdm.event.ICdmEventListener;
//import eu.etaxonomy.cdm.event.ICdmEventListenerRegistration;
//import eu.etaxonomy.cdm.model.name.TaxonName;
import eu.etaxonomy.taxeditor.designproposal2.controller.OpenNameEditorAction;
import eu.etaxonomy.taxeditor.designproposal2.Activator;

//public class NameListView extends ViewPart implements ICdmEventListener {
public class NameListView extends ViewPart {
	private Text searchText;
	private Table table;
	private Composite composite;
	private Tree tree;
	private Composite taxTreeComposite = null;
	private Composite recentNamesComposite = null;
	private Composite searchComposite = null;	
	private Composite top = null;
	private ExpandBar expandBar = null;
	private ExpandItem taxTreeExpandItem;
	private ExpandItem recentNamesExpandItem;
	private ExpandItem searchExpandItem;	
	public static final String ID = "eu.etaxonomy.taxeditor.designproposal2.view.namelistview"; //$NON-NLS-1$

	
	
	/**
	 * Create contents of the view part
	 * @param parent
	 */
	@Override
	public void createPartControl(Composite parent) {
		// TODO Auto-generated method stub
		parent.setLayout(new FillLayout());
		GridLayout gridLayout = new GridLayout();
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginWidth = 0;
		gridLayout.marginHeight = 0;
		gridLayout.verticalSpacing = 0;	
				
		top = new Composite(parent, SWT.NONE);
		top.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));

		composite = new Composite(top, SWT.NONE);
		composite.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		final GridLayout gridLayout_1 = new GridLayout();
		gridLayout_1.numColumns = 2;
		composite.setLayout(gridLayout_1);
		final Label lblDataSourceTitle = new Label(composite, SWT.NONE);
		lblDataSourceTitle.setFont(SWTResourceManager.getFont("Arial", 14, SWT.BOLD));
		lblDataSourceTitle.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		lblDataSourceTitle.setAlignment(SWT.CENTER);
		lblDataSourceTitle.setText(" Euro+Med");		
		
		final Label lblDbImg = new Label(composite, SWT.NONE);
		lblDbImg.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false));
		lblDbImg.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		lblDbImg.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/db.gif"));

		final Menu menu = new Menu(lblDbImg);
		lblDbImg.setMenu(menu);

		final MenuItem checkboxMenuItem = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem.setSelection(true);
		checkboxMenuItem.setText("Euro+Med (mssql://128.14.101.12:80/europlusmed)");

		final MenuItem checkboxMenuItem_1 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_1.setText("WP6 (mssql://128.14.101.13:80/wp6)");

		final MenuItem palmWebora1922299480pwMenuItem = new MenuItem(menu, SWT.NONE);
		palmWebora1922299480pwMenuItem.setText("Palm Web (ora://192.22.99.4:80/pw)");

		new MenuItem(menu, SWT.SEPARATOR);

		final MenuItem newDataSourceMenuItem = new MenuItem(menu, SWT.NONE);
		newDataSourceMenuItem.setText("New data source ...");
		
		final Label lblDataSource = new Label(composite, SWT.NONE);
		final GridData gd_lblDataSource = new GridData(SWT.LEFT, SWT.CENTER, false, false, 2, 1);
		gd_lblDataSource.heightHint = 16;
		lblDataSource.setLayoutData(gd_lblDataSource);
		lblDataSource.setFont(SWTResourceManager.getFont("Arial", 8, SWT.NONE));
		lblDataSource.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		lblDataSource.setAlignment(SWT.CENTER);
		lblDataSource.setText("  mssql://128.14.101.12:80/europlusmed");

		
		createExpandBar();
		top.setLayout(gridLayout);
		top.setTabList(new Control[] {composite, expandBar});
	}

	/**
	 * This method initializes expandBar
	 * 
	 */
	private void createExpandBar() {
		expandBar = new ExpandBar(top, SWT.V_SCROLL);
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.verticalAlignment = GridData.FILL;
		expandBar.setLayoutData(gridData);
		createNameListComposite();
		createRecentNamesComposite();
		createSearchComposite();
		
		createActions();
		initializeToolBar();
		initializeMenu();		
		
	}
	
	private void createNameListComposite() {


		
	}
	
	private void createRecentNamesComposite() {
		taxTreeExpandItem = new ExpandItem(expandBar, SWT.NONE, 0);
		taxTreeExpandItem.setExpanded(true);
		taxTreeExpandItem.setHeight(200);
		taxTreeExpandItem.setText("Taxonomic Tree");
//				IFileArrangerImages.IMG_HOME);
//		nameListExpandItem.setImage(image);
		
		taxTreeComposite = new Composite(expandBar, SWT.NONE);
		taxTreeComposite.setLayout(new FillLayout());
		taxTreeComposite.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		
		taxTreeExpandItem.setControl(taxTreeComposite);

		tree = new Tree(taxTreeComposite, SWT.FULL_SELECTION);
		tree.setItemCount(1);
		tree.addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(final MouseEvent e) {
				new OpenNameEditorAction("Pilosella").run();
			}
		});

		final TreeItem newItemTreeItem = new TreeItem(tree, SWT.NONE);
		newItemTreeItem.setChecked(true);
		newItemTreeItem.setText("Compositae Giseke");

		final TreeItem newItemTreeItem_1 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_1.setItemCount(1);
		newItemTreeItem_1.setText("Anthemideae Cass.");

		final TreeItem newItemTreeItem_2 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_2.setItemCount(1);
		newItemTreeItem_2.setText("Arctotideae Cass.");

		final TreeItem newItemTreeItem_3 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_3.setItemCount(1);
		newItemTreeItem_3.setText("Astereae Cass.");

		final TreeItem newItemTreeItem_4 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_4.setItemCount(1);
		newItemTreeItem_4.setText("Calenduleae Cass.");

		final TreeItem newItemTreeItem_5 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_5.setItemCount(1);
		newItemTreeItem_5.setText("Cardueae Cass.");

		final TreeItem newItemTreeItem_6 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_6.setText("Cichorieae Lam. & DC.");

		final TreeItem newItemTreeItem_16 = new TreeItem(newItemTreeItem_6, SWT.NONE);
		newItemTreeItem_16.setExpanded(true);
		newItemTreeItem_16.setText("Pilosella Vaill.");

		final TreeItem newItemTreeItem_17 = new TreeItem(newItemTreeItem_16, SWT.NONE);
		newItemTreeItem_17.setText("Pilosella fuscoatra coll.");

		final TreeItem newItemTreeItem_18 = new TreeItem(newItemTreeItem_17, SWT.NONE);
		newItemTreeItem_18.setFont(SWTResourceManager.getFont("", 8, SWT.BOLD));
		newItemTreeItem_18.setExpanded(true);
		newItemTreeItem_18.setText("Pilosella fuscoatra (Ngeli & Peter) Sojk");

		final TreeItem newItemTreeItem_7 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_7.setItemCount(1);
		newItemTreeItem_7.setText("Eupatorieae Cass.");

		final TreeItem newItemTreeItem_8 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_8.setItemCount(1);
		newItemTreeItem_8.setText("Gnaphalieae Lecoq & Juillet");

		final TreeItem newItemTreeItem_9 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_9.setItemCount(1);
		newItemTreeItem_9.setText("Helenieae Lindl.");

		final TreeItem newItemTreeItem_10 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_10.setItemCount(1);
		newItemTreeItem_10.setText("Heliantheae Cass.");

		final TreeItem newItemTreeItem_11 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_11.setItemCount(1);
		newItemTreeItem_11.setText("Inuleae Cass.");

		final TreeItem newItemTreeItem_12 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_12.setItemCount(1);
		newItemTreeItem_12.setText("Mutisieae Cass.");

		final TreeItem newItemTreeItem_13 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_13.setItemCount(1);
		newItemTreeItem_13.setText("Plucheeae Anderb.");

		final TreeItem newItemTreeItem_14 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_14.setItemCount(1);
		newItemTreeItem_14.setText("Senecioneae Cass.");

		final TreeItem newItemTreeItem_15 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_15.setItemCount(1);
		newItemTreeItem_15.setText("Vernonieae Cass.");
		taxTreeComposite.setTabList(new Control[] {tree});
		recentNamesExpandItem = new ExpandItem(expandBar, SWT.NONE, 1);
		recentNamesExpandItem.setHeight(130);
		recentNamesExpandItem.setExpanded(true);
		recentNamesExpandItem.setText("Recently viewed names");
		recentNamesComposite = new Composite(expandBar, SWT.NONE);
		final GridLayout gridLayout = new GridLayout();
		recentNamesComposite.setLayout(gridLayout);

		recentNamesExpandItem.setControl(recentNamesComposite);

		table = new Table(recentNamesComposite, SWT.NONE);
		table.addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(final MouseEvent e) {
				new OpenNameEditorAction("Carduus").run();
			}
		});
		table.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));

		final TableItem newItemTableItem = new TableItem(table, SWT.BORDER);
		newItemTableItem.setText("Laphangium (Hilliard & B. L. Burtt) Tzvelev");

		final TableItem newItemTableItem_1 = new TableItem(table, SWT.BORDER);
		newItemTableItem_1.setText("Carduus L.");

		final TableItem newItemTableItem_2 = new TableItem(table, SWT.BORDER);
		newItemTableItem_2.setText("Carduus carpetanus Boiss. & Reut.");

		final TableItem newItemTableItem_3 = new TableItem(table, SWT.BORDER);
		newItemTableItem_3.setText("Carduus kerneri Simonk.");

		final TableItem newItemTableItem_5 = new TableItem(table, SWT.BORDER);
		newItemTableItem_5.setText("Senecio eboracensis R. J. Abbott & A. J. Lowe");

		final TableItem newItemTableItem_6 = new TableItem(table, SWT.BORDER);
		newItemTableItem_6.setText("Senecio elegans L.");

//		Image image = FileArrangerImages.getImageRegistry().get(
//				IFileArrangerImages.IMG_BOOKMARK);
//		bookmarksExpandItem.setImage(image);
	}

	private void createSearchComposite() {
		searchExpandItem = new ExpandItem(expandBar, SWT.NONE, 2);
		searchExpandItem.setHeight(50);
		searchExpandItem.setExpanded(true);
		searchExpandItem.setText("Search");
		searchComposite = new Composite(expandBar, SWT.NONE);
		final GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		searchComposite.setLayout(gridLayout);

		searchExpandItem.setControl(searchComposite);

		searchText = new Text(searchComposite, SWT.BORDER);
		searchText.setForeground(SWTResourceManager.getColor(192, 192, 192));
		searchText.setText("Use \"*\" for wildcard searching");
		final GridData gd_useForText = new GridData(SWT.FILL, SWT.CENTER, true, false);
		searchText.setLayoutData(gd_useForText);
		searchText.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent e) {
				searchText.setForeground(SWTResourceManager.getColor(0,0,0));
				searchText.setText("");
			}

			public void focusLost(FocusEvent e) {
				if (searchText.getText() == "") {
					searchText.setForeground(SWTResourceManager.getColor(192, 192, 192));
					searchText.setText("Use \"*\" for wildcard searching");					
				}
				
			}
			
		});

		final Button searchButton = new Button(searchComposite, SWT.NONE);
		searchButton.setText("Search");

//		final Label carduusLLabel = new Label(searchComposite, SWT.NONE);
//		carduusLLabel.setLayoutData(gd_carduusLLabel);
//		carduusLLabel.setText("Carduus L.");
//
//		final Label carduusCarpetanusBoissLabel = new Label(searchComposite, SWT.NONE);
//		carduusCarpetanusBoissLabel.setLayoutData(gd_carduusCarpetanusBoissLabel);
//		carduusCarpetanusBoissLabel.setText("Carduus carpetanus Boiss. & Reut.");

//		Image image = FileArrangerImages.getImageRegistry().get(
//				IFileArrangerImages.IMG_FTP);
//		ftpExpandItem.setImage(image);
	}	
	
	private void createActions() {
		// Create the actions
	}

	/**
	 * Initialize the toolbar
	 */
	private void initializeToolBar() {
		IToolBarManager toolbarManager = getViewSite().getActionBars()
				.getToolBarManager();
	}

	/**
	 * Initialize the menu
	 */
	private void initializeMenu() {
		IMenuManager menuManager = getViewSite().getActionBars()
				.getMenuManager();
	}

	@Override
	public void setFocus() {
		// Set the focus
	}
	
	/**
	 * Refreshes a taxon name in the list
	 */
//	public void refreshElement(TaxonName taxonname) {
//	}

//	public void onDelete(ICdmEventListenerRegistration arg0) {
//		// TODO Auto-generated method stub
//		
//	}

	public void onInsert(Object arg0) {
		// TODO Auto-generated method stub
		
	}

	public void onLoad(Object arg0) {
	}

//	public void onUpdate(ICdmEventListenerRegistration arg0) {
//		System.out.println("here i am");
//		refreshElement((TaxonName)arg0);
//	}
	
}
