package eu.etaxonomy.taxeditor.prototype1.controller;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.PartInitException;

import eu.etaxonomy.taxeditor.prototype1.Activator;
import eu.etaxonomy.taxeditor.prototype1.model.NameEditorInput;
import eu.etaxonomy.taxeditor.prototype1.view.NameEditorView;
import eu.etaxonomy.cdm.model.name.TaxonName;

public class OpenNameEditorAction extends Action {

	private TaxonName taxonname;
	
	public OpenNameEditorAction(TaxonName taxonname) {
		this.taxonname = taxonname;
	}
	
	public void run() {
		
		Activator.getDefault().getRecentNamesList().add(this.taxonname);
		
		IEditorInput input = new NameEditorInput(taxonname);
        try {
        	Activator.getDefault().getWorkbench().getActiveWorkbenchWindow().
        		getActivePage().openEditor(input, NameEditorView.ID);
		} catch (PartInitException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}