/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.actions.cdm;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.Action;

import eu.etaxonomy.cdm.model.name.NameRelationship;
import eu.etaxonomy.cdm.model.name.TaxonNameBase;

/**
 * @author p.ciardelli
 * @created 06.06.2008
 * @version 1.0
 */
public class DeleteNameRelationAction extends Action {
	private static final Logger logger = Logger
			.getLogger(DeleteNameRelationAction.class);

	private TaxonNameBase name;
	private NameRelationship relation;
	
	public DeleteNameRelationAction(TaxonNameBase name, NameRelationship relation) {
		this.name = name;
		this.relation = relation;
	}
	
	public void run() {
		name.removeNameRelationship(relation);
	}

}
