package eu.etaxonomy.taxeditor.model;

import org.apache.log4j.Logger;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;

import eu.etaxonomy.cdm.model.name.NonViralName;
import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.cdm.model.taxon.Taxon;

/**
 * @author p.ciardelli
 *
 */
public class NameEditorInput implements IEditorInput {

	private static final Logger logger = Logger.getLogger(NameEditorInput.class);
	
	private Taxon taxon;
	
	public NameEditorInput (Taxon taxon) {
		this.taxon = taxon;
	}
	
	public boolean exists() {
		// TODO Auto-generated method stub
		return false;
	}

	public ImageDescriptor getImageDescriptor() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getName() {
		TaxonNameBase name = taxon.getName();
		if (name == null || name.getTitleCache() == null) {
			return "New taxon";
		} else  {
			return name.getTitleCache();
		}
	}

	public IPersistableElement getPersistable() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getToolTipText() {
		return getName();
	}

	public Object getAdapter(Class adapter) {

		if (adapter == Taxon.class) {
			return taxon;
		}
		
		return null;
	}

    /**
     * Overrides equals to ensure that a taxon can only be edited by
     *  one editor at a time.
     * 
     * @return boolean
     */	
	public boolean equals(Object obj) {
		if (obj.getClass().equals(NameEditorInput.class) 
				&& taxon.equals(((NameEditorInput) obj).taxon))
			return true;
		return false;
	}
}
